
import java.util.Hashtable;

/**
 * @author kiriman
 * @version 1.0
 *
 * Библиотека для переворота текста задом наперед и вверх ногами.
 * Обратный процесс не предусмотрен.
 * Пример:
 * Lib_FlipT.Flip("text");
 * З.Ы. За ошибки не ручаюсь, это всего лишь порт JS с FlipTitle.com.
 */
public class Lib_FlipT {

    static Hashtable fliptable = new Hashtable() {

        {
            put("a", String.valueOf('\u0250'));
            put("b", "q");
            put("c", String.valueOf('\u0254'));
            put("d", "p");
            put("e", String.valueOf('\u01DD'));
            put("f", String.valueOf('\u025F'));
            put("g", String.valueOf('\u0183'));
            put("h", String.valueOf('\u0265'));
            put("i", String.valueOf('\u0131'));
            put("j", String.valueOf('\u027E'));
            put("k", String.valueOf('\u029E'));
            /*l : '\u0283', */
            put("m", String.valueOf('\u026F'));
            put("n", "u");
            put("r", String.valueOf('\u0279'));
            put("t", String.valueOf('\u0287'));
            put("v", String.valueOf('\u028C'));
            put("w", String.valueOf('\u028D'));
            put("y", String.valueOf('\u028E'));
            put(".", String.valueOf('\u02D9'));
            put("[", "]");
            put("(", ")");
            put("{", "}");
            put("?", String.valueOf('\u00BF'));
            put("!", String.valueOf('\u00A1'));
            put("'", ",");
            put(",", "'");
            put("<", ">");
            put("_", String.valueOf('\u203E'));
            put(";", String.valueOf('\u061B'));
            put(String.valueOf('\u203F'), String.valueOf('\u2040'));
            put(String.valueOf('\u2045'), String.valueOf('\u2046'));
            put(String.valueOf('\u2234'), String.valueOf('\u2235'));
            put("\r", "\n");
        }
    };

    public static String Flip(String aString) {
        if (aString.equals(null) || aString.equals("")) {
            return "null";
        }
        aString = aString.toLowerCase();
        char[] str = aString.toCharArray();
        int last = aString.length() - 1;
        String rezult = "";
        for (int i = last; i >= 0; --i) {
            char c = aString.charAt(i);
            String gets = (String) fliptable.get(String.valueOf(c));
            str[last - i] = gets != null ? gets.charAt(0) : c;
            rezult += str[last - i];
        }
        return rezult;
    }
}
