
import java.io.DataOutputStream;
import java.io.IOException;
import java.util.Enumeration;
import javax.microedition.io.Connector;
import javax.microedition.io.file.FileConnection;
import javax.microedition.io.file.FileSystemRegistry;
import javax.microedition.lcdui.Command;
import javax.microedition.lcdui.CommandListener;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.Displayable;
import javax.microedition.lcdui.Form;
import javax.microedition.lcdui.TextBox;
import javax.microedition.lcdui.TextField;
import javax.microedition.midlet.MIDlet;

/**
 * @author kiriman
 * @version 1.0
 */
public class Text_Flip extends MIDlet implements CommandListener {

    Form f, aboutF;
    String s2;
    boolean z = true;
    TextBox tbSave;
    TextField tf, tf1;
    Command ok, save, saveTxt, about, exit, cancel;
    Display dsp;

    public Text_Flip() {
        dsp = Display.getDisplay(this);
        f = new Form("Text_Flip");
        exit = new Command("Выход", Command.SCREEN, 2);
        save = new Command("Сохранить", Command.SCREEN, 0);
        about = new Command("О программе", Command.SCREEN, 1);
        ok = new Command("OK", Command.EXIT, 1);
        tf = new TextField("Введите текст", null, 1000, TextField.ANY);
        tf1 = new TextField(">>", null, 1000, TextField.ANY);
        f.addCommand(ok);
        f.addCommand(exit);
        f.addCommand(save);
        f.addCommand(about);
        f.append(tf);
        f.append(tf1);
        f.setCommandListener(this);

        aboutF = new Form("О программе");
        aboutF.append("Text_Flip v 1.0\n* Эффективный троллинг\n* Усложнение паролей\nТекст вверх ногами? Теперь это просто!\nНекоторые символы отобразятся квадратами в поле ввода, не проблема, сохраняете файл, копируете в браузер, после отправки все станет на свои места, но возможно, видно их будет только на ПК.\n(с) kiriman, Красноярск, 2011");
        cancel = new Command("Назад", Command.BACK, 1);
        aboutF.addCommand(cancel);
        aboutF.setCommandListener(this);
    }

    public void startApp() {
        dsp.setCurrent(f);
    }

    public void pauseApp() {
    }

    public void destroyApp(boolean unconditional) {
        notifyDestroyed();
    }

    public void saveWin1251(String path, String str) {
        try {
            FileConnection fout = (FileConnection) Connector.open(path, Connector.WRITE);
            if (fout.exists()) {
                fout.delete();
            }
            fout.create();
            DataOutputStream dos = fout.openDataOutputStream();
            addText(str, dos);
            dos.close();
            fout.close();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }

    public void addText(String s1, DataOutputStream dos) {
        try {
            byte[] abyte0 = new byte[s1.length() + 1];
            for (int i = 0; i < abyte0.length - 1; i++) {
                char c = s1.charAt(i);
                if (c > '\377') {
                    abyte0[i] = (byte) (c - 848);
                } else {
                    abyte0[i] = (byte) c;
                }
                if (c == '\r') {
                    abyte0[i] = (byte) ('\n');

                }
            }
            dos.write(abyte0, 0, abyte0.length - 1);
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }

    public void commandAction(Command c, Displayable d) {
        if (c == ok) {
            tf1.setString(Lib_FlipT.Flip(tf.getString()));
        }
        if (c == exit) {
            destroyApp(true);
        }
        if (c == about) {
            dsp.setCurrent(aboutF);
        }
        if (c == cancel) {
            if (!z) {
                s2 = tbSave.getString();
            }
            dsp.setCurrent(f);
        }
        if (c == save) {
            if (z) {
                Enumeration CurrentDirEnum = null;
                CurrentDirEnum = FileSystemRegistry.listRoots();
                s2 = new String((String) CurrentDirEnum.nextElement());
            }
            z = false;
            tbSave = new TextBox("Сохранить", s2, 1000, TextField.ANY);
            saveTxt = new Command("OK", Command.OK, 0);
            tbSave.addCommand(saveTxt);
            tbSave.addCommand(cancel);
            tbSave.setCommandListener(this);
            dsp.setCurrent(tbSave);
        }
        if (c == saveTxt) {
            saveWin1251("file://" + tbSave.getString(), tf1.getString());
            dsp.setCurrent(f);
        }
    }
}
